subroutine calibrate

use params
use mini
implicit none

integer :: iter
integer, parameter :: itmax=150
double precision, parameter :: tol=1e-2/2
double precision :: d1, d2, d3, d4, d5, d6
double precision :: d7, d8, d9, d10, d11, d12
double precision :: dif
double precision, parameter :: hoursdata=0.3, medicaiddata=0.122, kydata=3.
double precision, parameter :: ydata=1, empinsureddata=1-0.345625143, empandpvtdata=0.50830285658
double precision, parameter :: ssnc_ydata=0.24432, ssc_ydata=0.29263    !average of 2006 to 2010
double precision, parameter :: hydata=0.1648215 !average of 2006 to 2010
double precision :: mscale

double precision :: sigma_s, eps_top, pi_top, rho_norm, rho_top

	computeasset=0

!initialize parameters
open(unit=1,file='input_param_guess.txt')
read(1,*)gamma
read(1,*)cmin
read(1,*)beta
read(1,*)theta
read(1,*)put_g(2)
read(1,*)b(1,1)
read(1,*)b(2,1)
read(1,*)mscale
read(1,*)sigma_s
read(1,*)eps_top
read(1,*)pi_top
read(1,*)rho_norm
read(1,*)rho_top
close(1)

!initilize
gamma=.574  !from French
sigma=1./gamma+1
bbeta=beta
!mscale=1

!b(1,1)=.25
!b(2,1)=.3

! 1 is privately insured, 2 is without private insurance, 3 is with employer insurance, 4 is with emp insurance, but not anymore
put_g(1)=0
!put_g(2)=0
put_g(3)=1-put_g(2)

!health productivity
z_h(1:2)=1
z_h(nh)=zero

!health endowment cost
phi_h=0
!fixed cost of working
phi_l=0

	!coverage for private insurance 
	cov_p=0.770633010864257		!0.779710312
	!coverage for employer insurance
	cov_e=cov_p

    open(unit=1,file='input_medical_expense.txt')
        do hc=1,nh
	read(1,*)e_h(hc,:)
	end do
    close(1)

e_h=e_h*mscale

ycat=ycatparam
kcat=1e35
ymn=ymnparam
kmn=amnparam

!Idiosyncratic productivities conditional on eduation status and resepctive transition probabilities
! open(unit=1,file='input_pi.txt')
! 	do ec=1,ne
! 		do sc=1,ns
! 		read(1,*)pi(ec,:,sc)
! 		end do
! 	end do
! 
! 	do ec=1,ne
! 	read(1,*)eta(ec,:)
! 	end do
! close(1)

!sigma_s=1.5
!eps_top=9
!pi_top=.001
!rho_norm=.97
!rho_top=.8

eta(1,2)=1
eta(1,1)=1./sigma_s
eta(1,3)=sigma_s
eta(1,4)=eps_top

pi=zero
pi(1,1,1)=rho_norm
pi(1,4,1)=pi_top
pi(1,2,1)=1-rho_norm-pi_top
pi(1,2,2)=rho_norm
pi(1,4,2)=pi_top
pi(1,1,2)=(1-rho_norm-pi_top)/2
pi(1,3,2)=(1-rho_norm-pi_top)/2
pi(1,3,3)=rho_norm
pi(1,4,3)=pi_top
pi(1,2,3)=1-rho_norm-pi_top
pi(1,4,4)=rho_top
pi(1,3,4)=1-rho_top
pi(2,:,:)=pi(1,:,:)
eta(2,:)=eta(1,:)
	
	cmin=0.027803285619	!calculated from average monthly foodstamp 2006-2010

iter=0
dif=1

	do while ( iter .le. itmax .and. abs(dif) .ge. tol )

            call markov
	
            avg_medical_expense_by_age=zero

                do ec=1,ne
                do hc=1,nh
                do tc=1,J
                avg_medical_expense_by_age(tc,ec)=avg_medical_expense_by_age(tc,ec)+e_h(hc,tc)*Nu(ec,hc,tc,1)/sum(Nu(ec,:,tc,1))
                end do
                end do
                end do
    
            var_medical_expense_by_age=zero

                do ec=1,ne
                do hc=1,nh
                do tc=1,J
                var_medical_expense_by_age(tc,ec)=var_medical_expense_by_age(tc,ec)+((e_h(hc,tc)-avg_medical_expense_by_age(tc,ec))**2)*Nu(ec,hc,tc,1)/sum(Nu(ec,:,tc,1))
                end do
                end do
                end do

            if ( rank .eq. 0 ) then
    
                open (unit=1,file='output_avg_std_medical_expense_by_age.txt')
                    do tc=1,J
                    write(1,'(I2,300F12.5)')tc+19,avg_medical_expense_by_age(tc,:),sqrt(var_medical_expense_by_age(tc,1)),sqrt(var_medical_expense_by_age(tc,2))
                    end do
                close(1)
        
            end if	
            
            call instst	

!	d1=abs(hour(1)-hoursdata)
!	d2=abs(foodstamp(1)*sum(nuss)/wapss-medicaiddata)
	d1=0
	d2=0
	d3=abs(K(1)/Y(1)-kydata)
	d4=abs(ydata-Y(1)/sum(nuss))
	d5=abs(empandpvtdata-(pvtinsuredss+employerss)*sum(nuss)/sum(Nuss(:,:,1:jr-1)))
	d6=max(abs(ssnc_ydata-SSss(1)),abs(ssc_ydata-SSss(2)))
	d7=abs(hydata-Hss/Y(1))
	d8=abs(ginicoeflabearnings(1)-ginicoeflabearnings(2))
	d9=abs(toplabearnings(1,3)-toplabearnings(2,3))
	d10=abs(sum(toplabearnings(1,:))-sum(toplabearnings(2,:)))
	d11=abs(pb80(1)-pb80(2))
	d12=abs(pt99(1)-pt99(2))

	dif=max(d1,d2,d3,d4,d5/2,d6,d7,d8,d9,d10,d11,d12)

!	gamma=gamma*(hoursdata/hour(1))**0.3
!	cmin=cmin*(medicaiddata/(foodstamp(1)*sum(nuss)/wapss))**0.025

            if ( dif .ge. tol ) then
	
            beta=beta*(kydata/(K(1)/Y(1)))**0.1
            theta=theta*(ydata/(Y(1)/sum(nuss)))**0.3
            put_g(2)=put_g(2)*(((pvtinsuredss+employerss)*sum(nuss)/sum(nuss(:,:,1:jr-1)))/empandpvtdata)**0.4
            b(1,1)=b(1,1)*(ssnc_ydata/SSss(1))**0.2
            b(2,1)=b(2,1)*(ssc_ydata/SSss(2))**0.2
            mscale=mscale*(hydata/(Hss/Y(1)))**0.2
            sigma_s=sigma_s*(ginicoeflabearnings(1)/ginicoeflabearnings(2))**.25
            eps_top=eps_top*(toplabearnings(1,3)/toplabearnings(2,3))**.25
            pi_top=pi_top*(sum(toplabearnings(1,:))/sum(toplabearnings(2,:)))**.4
            rho_norm=rho_norm*(pb80(1)/pb80(2))**0.05
            rho_top=rho_top*(pt99(1)/pt99(2))**0.025
		
            sigma=1./gamma+1
            bbeta=beta
            put_g(3)=1-put_g(2)

                open(unit=1,file='input_medical_expense.txt')
                    do hc=1,nh
                    read(1,*)e_h(hc,:)
                    end do
                close(1)

            e_h=e_h*mscale
    
            eta(1,2)=1
            eta(1,1)=1./sigma_s
            eta(1,3)=sigma_s
            eta(1,4)=eps_top

            pi=zero
            pi(1,1,1)=rho_norm
            pi(1,4,1)=pi_top
            pi(1,2,1)=1-rho_norm-pi_top
            pi(1,2,2)=rho_norm
            pi(1,4,2)=pi_top
            pi(1,1,2)=(1-rho_norm-pi_top)/2
            pi(1,3,2)=(1-rho_norm-pi_top)/2
            pi(1,3,3)=rho_norm
            pi(1,4,3)=pi_top
            pi(1,2,3)=1-rho_norm-pi_top	
            pi(1,4,4)=rho_top
            pi(1,3,4)=1-rho_top
            pi(2,:,:)=pi(1,:,:)
            eta(2,:)=eta(1,:)

            end if
	
	iter=iter+1

		if ( rank .eq. 0 ) then
		
		print*,'cali, dif ',iter,dif
		print*,d1,d2,d3,d4
		print*,d5,d6,d7,d8
		print*,d9,d10,d11,d12
		print*,'gamma, hours ',gamma,hoursdata,hour(1)
		print*,'cmin, welfare ',cmin,medicaiddata,foodstamp(1)
		print*,'beta, K/Y ',beta,kydata,K(1)/Y(1)
		print*,'theta, y ',theta,ydata,y(1)/sum(nuss)
		print*,'put_g(2), emp insurance ',put_g(2),empandpvtdata,(pvtinsuredss+employerss)*sum(nuss)/sum(Nuss(:,:,1:jr-1))
		print*,'b_nc, SSnc/y ',b(1,1),ssnc_ydata,SSss(1)
		print*,'b_c, SSc/y ',b(2,1),ssc_ydata,SSss(2)
		print*,'mscale, H/Y ',mscale,hydata,Hss/Y(1)
		print*,'sigma_s, gini_lab ',sigma_s,ginicoeflabearnings(1),ginicoeflabearnings(2)
		print*,'eps_top, top1_lab ',eps_top,toplabearnings(1,3),toplabearnings(2,3)
		print*,'pi_top, top10_lab ',pi_top,sum(toplabearnings(1,:)),sum(toplabearnings(2,:))
		print*,'rho_norm, pb80 ',rho_norm,pb80(1),pb80(2)
		print*,'rho_top, pt99 ',rho_top,pt99(1),pt99(2)
		
                    open(unit=1,file='input_param_guess.txt')
                    write(1,*)gamma
                    write(1,*)cmin
                    write(1,*)beta
                    write(1,*)theta
                    write(1,*)put_g(2)
                    write(1,*)b(1,1)
                    write(1,*)b(2,1)
                    write(1,*)mscale
                    write(1,*)sigma_s
                    write(1,*)eps_top
                    write(1,*)pi_top
                    write(1,*)rho_norm
                    write(1,*)rho_top
                    close(1)
			
		end if

	end do

b(1,2:time)=b(1,1)
b(2,2:time)=b(2,1)

!b(1,3:time)=zero
!b(2,3:time)=zero

ycat(2:time)=ycat(1)
kcat(2:time)=kcat(1)
ymn(2:time)=ymn(1)
kmn(2:time)=kmn(1)

!ACA Medicaid expansion
! ycat(2:time)=FPL*1.38
! kcat(2:time)=1e35
! ymn(2:time)=-1e35
! kmn(2:time)=1e35


	if ( rank .eq. 0 ) then
	print*,'Done with calibration '
	end if

	if ( abs(dif) .ge. tol .and. rank .eq. 0 ) then
	print*,'dif exceeded tol at calibration ',dif
!		call exit
	end if


    computeasset=1

    
end subroutine calibrate
