module mini
use params

contains

subroutine percentile (p1,n,x,perc)
implicit none

double precision, intent(in) :: p1
integer, intent(in) :: n
double precision, intent(in) :: x(n,2)
double precision, intent(out) :: perc

double precision :: temp
integer :: cnt, check

    check=0
    
    do cnt=1,n
	
    temp=temp+x(cnt,2)
        
        if ( temp .gt. p1 .and. check .eq. 0 ) then
        
        check=1
        perc=x(cnt,1)
	
        end if
            
    end do
	
end subroutine percentile

subroutine persistence (p1,p2,phi1,pers,x,n,m)
!p1 and p2 are quintile cutoffs
!phi1 is distribution
!pers is persistance for p1 and p2
!x is distribution and n is number of elements
!m is number of unique elements
implicit none

double precision, intent(in) :: p1, p2
double precision, intent(in), dimension(ng,ne,nh,ns,na,J) :: phi1
double precision, intent(out) :: pers
double precision, dimension(ng,ne,nh,ns,na,J) :: phi2, phi3, phi4
integer, intent(in) :: n, m
double precision, intent(in) :: x(n,2)

double precision :: ly, ly1, ly2
double precision, dimension(2) :: vals
integer, dimension (2) :: inds
integer :: hcc, scc, tcc, iter

double precision :: y(m,2), ycum(m+1,2)
integer :: cnt, i

    cnt=1
y=0
y(1,:)=x(1,:)

    !get distribution 
    do i=2,n
        if ( x(i,1) .ne. x(i-1,1) ) then
        cnt=cnt+1
        y(cnt,:)=x(i,:)
        else if ( x(i,1) .eq. x(i-1,1) ) then
        y(cnt,2)=y(cnt,2)+x(i,2)
        end if	
    end do

ycum=zero
ycum(2:m+1,:)=y(1:m,:)

    do i=2,m+1
    ycum(i,2)=ycum(i-1,2)+ycum(i,2)
    end do

    if ( p1 .eq. zero ) then
    ly1=ycum(1,1)
    else if ( p1 .eq. one ) then
    ly1=ycum(m+1,1)
    else

        if ( ycum(2,2) .gt. p1 ) then
        ly1=ycum(2,1)
        else
            call basefun(ycum(:,2),m+1,p1,vals,inds)
        ly1=vals(1)*ycum(inds(1),1)+vals(2)*ycum(inds(2),1)
        end if
        
    end if

    if ( p2 .eq. zero ) then
    ly2=ycum(1,1)
    else if ( p2 .eq. one ) then
    ly2=ycum(m+1,1)
    else

        if ( ycum(2,2) .gt. p2 ) then
        ly2=ycum(2,1)
        else
            call basefun(ycum(:,2),m+1,p2,vals,inds)
        ly2=vals(1)*ycum(inds(1),1)+vals(2)*ycum(inds(2),1)
        end if
    end if

!find individuals within threshold
phi2=0

    do tc=1,J
    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na

!        if ( tc .lt. jr ) then
        ly=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)
!        else
!        ly=SSss(ec)+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)
!        end if

        if ( ly .ge. ly1 .and. ly .le. ly2 ) then
        phi2(gc,ec,hc,sc,ac,tc)=phi1(gc,ec,hc,sc,ac,tc)
        end if

    end do
    end do
    end do
    end do
    end do
    end do

!simulate them twice
phi3=phi2

    do iter=1,2
    
    phi4=0

        do tc=1,J

            if ( tc .eq. J ) then
            tcc=tc
            else
            tcc=tc+1
            end if

            do gc=1,ng
            do ec=1,ne
            do hc=1,nh
            do sc=1,ns
            do ac=1,na

                call basefun(grida,na,afunss(gc,ec,hc,sc,ac,tc),vals,inds)
			
                do hcc=1,nh
                do scc=1,ns	

                    if ( g_dgss(gc,ec,hc,sc,ac,tc) .eq. 1 .and. ( gc .eq. 1 .or. gc .eq. 2 ) ) then 

                    Phi4(1,ec,hcc,scc,inds(1),tcc)=Phi4(1,ec,hcc,scc,inds(1),tcc)+&
                    Phi3(gc,ec,hc,sc,ac,tc)*vals(1)*pi(ec,scc,sc)*pi_h(ec,tc,hcc,hc)*psi(ec,hc,tc)
                    Phi4(1,ec,hcc,scc,inds(2),tcc)=Phi4(1,ec,hcc,scc,inds(2),tcc)+&
                    Phi3(gc,ec,hc,sc,ac,tc)*vals(2)*pi(ec,scc,sc)*pi_h(ec,tc,hcc,hc)*psi(ec,hc,tc)
                    
                    else if ( g_dgss(gc,ec,hc,sc,ac,tc) .eq. 0 .and. ( gc .eq. 1 .or. gc .eq. 2 ) ) then 

                    Phi4(2,ec,hcc,scc,inds(1),tcc)=Phi4(2,ec,hcc,scc,inds(1),tcc)+&
                    Phi3(gc,ec,hc,sc,ac,tc)*vals(1)*pi(ec,scc,sc)*pi_h(ec,tc,hcc,hc)*psi(ec,hc,tc)
                    Phi4(2,ec,hcc,scc,inds(2),tcc)=Phi4(2,ec,hcc,scc,inds(2),tcc)+&
                    Phi3(gc,ec,hc,sc,ac,tc)*vals(2)*pi(ec,scc,sc)*pi_h(ec,tc,hcc,hc)*psi(ec,hc,tc)
		
                    else if ( gc .eq. 3  .and. g_dgss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then 

                    Phi4(1,ec,hcc,scc,inds(1),tcc)=Phi4(1,ec,hcc,scc,inds(1),tcc)+&
                    Phi3(gc,ec,hc,sc,ac,tc)*vals(1)*pi(ec,scc,sc)*pi_h(ec,tc,hcc,hc)*psi(ec,hc,tc)
                    Phi4(1,ec,hcc,scc,inds(2),tcc)=Phi4(1,ec,hcc,scc,inds(2),tcc)+&
                    Phi3(gc,ec,hc,sc,ac,tc)*vals(2)*pi(ec,scc,sc)*pi_h(ec,tc,hcc,hc)*psi(ec,hc,tc)

                    else if ( gc .eq. 3  .and. g_dgss(gc,ec,hc,sc,ac,tc) .eq. 0 ) then 
										
                    Phi4(3,ec,hcc,scc,inds(1),tcc)=Phi4(3,ec,hcc,scc,inds(1),tcc)+&
                    Phi3(gc,ec,hc,sc,ac,tc)*vals(1)*pi(ec,scc,sc)*pi_h(ec,tc,hcc,hc)*psi(ec,hc,tc)
                    Phi4(3,ec,hcc,scc,inds(2),tcc)=Phi4(3,ec,hcc,scc,inds(2),tcc)+&
                    Phi3(gc,ec,hc,sc,ac,tc)*vals(2)*pi(ec,scc,sc)*pi_h(ec,tc,hcc,hc)*psi(ec,hc,tc)
		
                    end if
					
                end do
                end do
	
            end do
            end do
            end do
            end do
            end do
            end do

        phi3=phi4
        
        end do        

phi4=0

    do tc=1,J
    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na

!        if ( tc .lt. jr ) then
        ly=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)
!        else
!        ly=SSss(ec)+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lfunss(gc,ec,hc,sc,ac,tc)
!        end if

        if ( ly .ge. ly1 .and. ly .le. ly2 ) then
        phi4(gc,ec,hc,sc,ac,tc)=phi3(gc,ec,hc,sc,ac,tc)
        end if
        
    end do
    end do
    end do
    end do
    end do
    end do

pers=sum(phi4)/sum(phi3)

end subroutine persistence


subroutine ineqmoments (vec,n,quint,top)
implicit none

integer, intent(in) :: n
double precision, intent(in) :: vec(n,2)
double precision, intent(out) :: quint(5), top(3)

double precision :: vals(2), dummy
integer :: inds(2)

	call basefun(vec(:,1),n,0.2d0,vals,inds)
quint(1)=vals(1)*vec(inds(1),2)+vals(2)*vec(inds(2),2)

	call basefun(vec(:,1),n,0.4d0,vals,inds)
quint(2)=vals(1)*vec(inds(1),2)+vals(2)*vec(inds(2),2)-quint(1)

	call basefun(vec(:,1),n,0.6d0,vals,inds)
quint(3)=vals(1)*vec(inds(1),2)+vals(2)*vec(inds(2),2)-quint(2)-quint(1)

	call basefun(vec(:,1),n,0.8d0,vals,inds)
quint(4)=vals(1)*vec(inds(1),2)+vals(2)*vec(inds(2),2)-quint(3)-quint(2)-quint(1)

quint(5)=1.d0-quint(4)-quint(3)-quint(2)-quint(1)

	call basefun(vec(:,1),n,.9d0,vals,inds)
dummy=vals(1)*vec(inds(1),2)+vals(2)*vec(inds(2),2)

	call basefun(vec(:,1),n,.95d0,vals,inds)
top(1)=vals(1)*vec(inds(1),2)+vals(2)*vec(inds(2),2)-dummy

	call basefun(vec(:,1),n,.99d0,vals,inds)
top(2)=vals(1)*vec(inds(1),2)+vals(2)*vec(inds(2),2)-top(1)-dummy

top(3)=1.d0-top(2)-top(1)-dummy

end subroutine ineqmoments


subroutine lorenz(x,n,y,m,gini,cv,vlog,avg,median)
implicit none
integer, intent(in) :: n, m
double precision :: x(n,2)
double precision :: y(m,2), z(m,2), sum1, sum2
double precision :: gini, Si(m+1), cv, vlog
integer :: i, cnt, j
double precision :: avg, std, median
double precision, allocatable :: vl(:,:)
double precision :: avgvl
integer :: vcnt

double precision :: ycum(m+1,2)

double precision :: vals(2)
integer :: inds(2)

	cnt=1
	y=0
	y(1,:)=x(1,:)

!get distribution 
	do i=2,n
		if ( x(i,1) .ne. x(i-1,1) ) then
		cnt=cnt+1
		y(cnt,:)=x(i,:)
		else if ( x(i,1) .eq. x(i-1,1) ) then
		y(cnt,2)=y(cnt,2)+x(i,2)
		end if	
	end do

!median
ycum=zero
ycum(2:m+1,:)=y(1:m,:)

	do i=2,m+1
	ycum(i,2)=ycum(i-1,2)+ycum(i,2)
	end do

	if ( ycum(2,2) .gt. .5d0 ) then
	median=ycum(2,1)
	else
		call basefun(ycum(:,2),m+1,.5d0,vals,inds)
	median=vals(1)*ycum(inds(1),1)+vals(2)*ycum(inds(2),1)
	end if

!average of distribution
avg=0
	do i=1,m
	avg=avg+y(i,1)*y(i,2)
	end do

!standard deviation
	do i=1,m
	std=std+y(i,2)*(y(i,1)-avg)**2
	end do

std=sqrt(std)

!coefficient of variation
	cv=std/avg

!variance of logarithms

!remove negative values for variance of logarithms
vcnt=0

	do i=1,m
		if ( y(i,1) .gt. zero ) then
		vcnt=vcnt+1
		end if
	end do

!re-compute distribution with positives

	allocate (vl(vcnt,2))

	vcnt=0

		do i=1,m
			if ( y(i,1) .gt. zero ) then
			vcnt=vcnt+1
			vl(vcnt,:)=y(i,:)		
			end if
		end do

	vl(:,1)=log(vl(:,1))
	vl(:,2)=vl(:,2)/sum(vl(:,2))

!average of log

avgvl=0
vlog=0

	do i=1,vcnt
	avgvl=avgvl+vl(i,1)*vl(i,2)
	end do

!variance of logs
	do i=1,vcnt
	vlog=vlog+vl(i,2)*(vl(i,1)-avgvl)**2
	end do

	deallocate(vl)

!gini coefficient
z=y

	do i=1,m
	!mass
	y(i,1)=z(i,2)
	!mass times value
	y(i,2)=z(i,1)*z(i,2)
	end do

gini=0
Si=0
	do i=1,m
		do j=1,i
		Si(i+1)=Si(i+1)+y(j,2)
		end do
	end do

	do i=1,m
	gini=gini+y(i,1)*(Si(i)+Si(i+1))/Si(m+1)
	end do
gini=1-gini

sum1=sum(y(:,1))
sum2=sum(y(:,2))

	do i=1,m
	y(i,1)=y(i,1)/sum1
	y(i,2)=y(i,2)/sum2
	end do

	do i=2,m
	y(i,1)=y(i,1)+y(i-1,1)
	y(i,2)=y(i,2)+y(i-1,2)
	end do

end subroutine lorenz
! 
! subroutine lorenz(x,n,y,m,gini)
! implicit none
! integer, intent(in) :: n, m
! double precision, intent(in) :: x(n,2)
! double precision, intent(out) :: y(m,2)
! double precision :: z(m,2), sum1, sum2
! double precision :: gini, Si(m+1)
! integer :: i, cnt, j
! 
! 	cnt=1
! 	y=0
! 	y(1,:)=x(1,:)
! 
! 	do i=2,n
! 		if ( x(i,1) .ne. x(i-1,1) ) then
! 		cnt=cnt+1
! 		y(cnt,:)=x(i,:)
! 		else if ( x(i,1) .eq. x(i-1,1) ) then
! 		y(cnt,2)=y(cnt,2)+x(i,2)
! 		end if	
! 	end do
! 
! z=y
! 
! 	do i=1,m
! 	y(i,1)=z(i,2)
! 	y(i,2)=z(i,1)*z(i,2)
! 	end do
! 
! gini=0
! Si=0
! 	do i=1,m
! 		do j=1,i
! 		Si(i+1)=Si(i+1)+y(j,2)
! 		end do
! 	end do
! 
! 	do i=1,m
! 	gini=gini+y(i,1)*(Si(i)+Si(i+1))/Si(m+1)
! 	end do
! gini=1-gini
! 
! sum1=sum(y(:,1))
! sum2=sum(y(:,2))
! 
! 	do i=1,m
! 	y(i,1)=y(i,1)/sum1
! 	y(i,2)=y(i,2)/sum2
! 	end do
! 
! 	do i=2,m
! 	y(i,1)=y(i,1)+y(i-1,1)
! 	y(i,2)=y(i,2)+y(i-1,2)
! 	end do
! 
! end subroutine lorenz
 
subroutine unique(x,n,cnt)
implicit none
double precision, intent(in) :: x(n,2)
integer, intent(out) :: cnt
integer, intent(in) :: n
integer :: i

	cnt=1

	do i=2,n
		if ( x(i,1) .ne. x(i-1,1) ) then
		cnt=cnt+1
		end if	
	end do

end subroutine unique

subroutine sort(x,n)
implicit none
integer, intent(in) :: n
double precision, dimension(n,2), intent(inout) :: x

integer :: i, location
double precision :: y(n)

y(:)=x(:,1)

	do i=1,n-1
	location=findmin(y,i,n)
		call swap(x(i,:),x(location,:))
	y(:)=x(:,1)
	end do

end subroutine sort


function findmin (x,beg,en)
implicit none
double precision, dimension(:), intent(in) :: x
integer, intent(in) :: beg, en

double precision :: minimum
integer :: location, i
integer :: findmin

minimum=x(beg)
location=beg

	do i=beg+1,en
		if ( x(i) .le. minimum ) then
		minimum=x(i)
		location=i
		end if
	end do

findmin=location

end function findmin

subroutine swap(a,b)
implicit none
double precision, intent(inout) :: a(2), b(2)
double precision :: temp(2)
temp=a
a=b
b=temp
end subroutine swap

subroutine onedlin (x,y,n,x1,y1)
implicit none
integer, intent(in) :: n
double precision, intent(in) :: x(n), y(n), x1
double precision, intent(out) :: y1
integer :: point
    
    if ( x1 .lt. x(1) ) then
    
    point=1
    y1=y(point)+(x1-x(point))*(y(point+1)-y(point))/(x(point+1)-x(point))
    
    else if ( x1 .gt. x(n) ) then
    
    point=n-1
    y1=y(point)+(x1-x(point))*((y(point+1)-y(point))/(x(point+1)-x(point)))
    
    else
    
    point=1
    
	do while ( point .lt. n )

		if ( x1 .ge. x(point) .and. x1 .le. x(point+1) ) then
		y1=y(point)+(x1-x(point))*(y(point+1)-y(point))/(x(point+1)-x(point))
		point=point+n+100		
		end if

	point=point+1
	end do

    end if

end subroutine onedlin

! subroutine onedlin (x,y,n,x1,y1)
! implicit none
! integer, intent(in) :: n
! double precision, intent(in) :: x(n), y(n), x1
! double precision, intent(out) :: y1
! integer :: point
! 
! point=1
! 	do while ( point .lt. n )
! 
! 		if ( x1 .ge. x(point) .and. x1 .le. x(point+1) ) then
! 		y1=y(point)+(x1-x(point))*(y(point+1)-y(point))/(x(point+1)-x(point))
! 		point=point+n+100
! 		end if
! 
! 	point=point+1
! 	end do
! 
! end subroutine onedlin

SUBROUTINE nrerror(string)
IMPLICIT NONE
CHARACTER(LEN=*), INTENT(IN) :: string
	write (*,*) 'nrerror: ',string
STOP 'program terminated by nrerror'
END SUBROUTINE nrerror


FUNCTION brent(ax,bx,cx,tol,xmin,func)
IMPLICIT NONE

double precision, INTENT(IN) :: ax,bx,cx,tol
double precision, INTENT(OUT) :: xmin
double precision :: brent

INTEGER, PARAMETER :: ITMAX=1000
double precision , PARAMETER :: CGOLD=0.3819660 ,ZEPS=1.0e-3*epsilon(ax)
INTEGER :: iter
double precision  :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm

	interface 
		function func (x)
		double precision, intent(in) :: x
		double precision :: func
		end function func
	end interface 

	a=min(ax,cx)
	b=max(ax,cx)
	v=bx
	w=v
	x=v
	e=0.0
	fx=func(x)
	fv=fx
	fw=fx
	do iter=1,ITMAX
		xm=0.5*(a+b)
		tol1=tol*abs(x)+ZEPS
		tol2=2.0*tol1
		if (abs(x-xm) <= (tol2-0.5*(b-a))) then
			xmin=x
			brent=fx
			RETURN
		end if
		if (abs(e) > tol1) then
			r=(x-w)*(fx-fv)
			q=(x-v)*(fx-fw)
			p=(x-v)*q-(x-w)*r
			q=2.0*(q-r)
			if (q > 0.0) p=-p
			q=abs(q)
			etemp=e
			e=d
			if (abs(p) >= abs(0.5*q*etemp) .or. &
				p <= q*(a-x) .or. p >= q*(b-x)) then
				e=merge(a-x,b-x, x >= xm )
				d=CGOLD*e
			else
				d=p/q
				u=x+d
				if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
			end if
		else
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		end if
		u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )
		fu=func(u)
		if (fu <= fx) then
			if (u >= x) then
				a=x
			else
				b=x
			end if
			call shft(v,w,x,u)
			call shft(fv,fw,fx,fu)
		else
			if (u < x) then
				a=u
			else
				b=u
			end if
			if (fu <= fw .or. w == x) then
				v=w
				fv=fw
				w=u
				fw=fu
			else if (fu <= fv .or. v == x .or. v == w) then
				v=u
				fv=fu
			end if
		end if
	end do
	call nrerror('brent: exceed maximum iterations')
END FUNCTION brent


SUBROUTINE splie2(x1a,x2a,ya,y2a)
IMPLICIT NONE
double precision, DIMENSION(:), INTENT(IN) :: x1a,x2a
double precision, DIMENSION(:,:), INTENT(IN) :: ya
double precision, DIMENSION(:,:), INTENT(OUT) :: y2a
INTEGER :: j,m,ndum
double precision, PARAMETER :: yp1=1e30, ypn=yp1
m=size(x1a)
ndum=size(x2a)

	DO j=1,m
	CALL spline(x2a,ya(j,:),yp1,ypn,y2a(j,:))
	ENDDO

END SUBROUTINE splie2


FUNCTION splin2(x1a,x2a,ya,y2a,x1,x2)
IMPLICIT NONE
double precision, DIMENSION(:), INTENT(IN) :: x1a,x2a
double precision, DIMENSION(:,:), INTENT(IN) :: ya,y2a
double precision, INTENT(IN) :: x1,x2
double precision :: splin2
INTEGER :: j,m,ndum
double precision, DIMENSION(size(x1a)) :: yytmp,y2tmp2
double precision, PARAMETER :: yp1=1e30, ypn=yp1

	m=size(x1a)
	ndum=size(x2a)

	do j=1,m
		yytmp(j)=splint(x2a,ya(j,:),y2a(j,:),x2)
	end do

	call spline(x1a,yytmp,yp1,ypn,y2tmp2)
	splin2=splint(x1a,yytmp,y2tmp2,x1)

END FUNCTION splin2

SUBROUTINE shft(a,b,c,d)
double precision , INTENT(OUT) :: a
double precision , INTENT(INOUT) :: b,c
double precision , INTENT(IN) :: d
	a=b
	b=c
	c=d
END SUBROUTINE shft


SUBROUTINE mov3(a,b,c,d,e,f)
IMPLICIT NONE
double precision, INTENT(IN) :: d,e,f
double precision, INTENT(OUT) :: a,b,c
	a=d
	b=e
	c=f
END SUBROUTINE mov3

SUBROUTINE spline(x,y,yp1,ypn,y2)
IMPLICIT NONE
double precision, DIMENSION(:), INTENT(IN) :: x,y
double precision, INTENT(IN) :: yp1,ypn
double precision, DIMENSION(:), INTENT(OUT) :: y2
INTEGER :: n
double precision, DIMENSION(size(x)) :: a,b,c,r

	n=size(x)
	c(1:n-1)=x(2:n)-x(1:n-1)
	r(1:n-1)=6.0*((y(2:n)-y(1:n-1))/c(1:n-1))
	r(2:n-1)=r(2:n-1)-r(1:n-2)
	a(2:n-1)=c(1:n-2)
	b(2:n-1)=2.0*(c(2:n-1)+a(2:n-1))
	b(1)=1.0
	b(n)=1.0
	if (yp1 > 0.99e30) then
		r(1)=0.0
		c(1)=0.0
	else
		r(1)=(3.0/(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
		c(1)=0.5
	end if
	if (ypn > 0.99e30) then
		r(n)=0.0
		a(n)=0.0
	else
		r(n)=(-3.0/(x(n)-x(n-1)))*((y(n)-y(n-1))/(x(n)-x(n-1))-ypn)
		a(n)=0.5
	end if
	call tridag(a(2:n),b(1:n),c(1:n-1),r(1:n),y2(1:n))
END SUBROUTINE spline

FUNCTION splint(xa,ya,y2a,x)
IMPLICIT NONE
double precision, DIMENSION(:), INTENT(IN) :: xa,ya,y2a
double precision, INTENT(IN) :: x
double precision :: splint
INTEGER :: khi,klo,n
double precision :: a,b,h
	n=size(xa)
	klo=max(min(locate(xa,x),n-1),1)
	khi=klo+1
	h=xa(khi)-xa(klo)
	if (h == 0.0) call nrerror('bad xa input in splint')
	a=(xa(khi)-x)/h
	b=(x-xa(klo))/h
	splint=a*ya(klo)+b*ya(khi)+((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.0
END FUNCTION splint

SUBROUTINE tridag(a,b,c,r,u)
IMPLICIT NONE
double precision, DIMENSION(:), INTENT(IN) :: a,b,c,r
double precision, DIMENSION(:), INTENT(OUT) :: u
double precision, DIMENSION(size(b)) :: gam
INTEGER :: n,j
double precision :: bet
	n=size(a)+1
	bet=b(1)
	if (bet == 0.0) call nrerror('tridag_ser: Error at code stage 1')
	u(1)=r(1)/bet
	do j=2,n
		gam(j)=c(j-1)/bet
		bet=b(j)-a(j-1)*gam(j)
		if (bet == 0.0) &
			call nrerror('tridag_ser: Error at code stage 2')
		u(j)=(r(j)-a(j-1)*u(j-1))/bet
	end do
	do j=n-1,1,-1
		u(j)=u(j)-gam(j+1)*u(j+1)
	end do
END SUBROUTINE tridag

FUNCTION locate(xx,x)
IMPLICIT NONE
double precision, DIMENSION(:), INTENT(IN) :: xx
double precision, INTENT(IN) :: x
INTEGER:: locate
INTEGER :: n,jl,jm,ju
LOGICAL :: ascnd

	n=size(xx)
	ascnd = (xx(n) >= xx(1))
	jl=0
	ju=n+1
	do
		if (ju-jl <= 1) exit
		jm=(ju+jl)/2
		if (ascnd .eqv. (x >= xx(jm))) then
			jl=jm
		else
			ju=jm
		end if
	end do
	if (x == xx(1)) then
		locate=1
	else if (x == xx(n)) then
		locate=n-1
	else
		locate=jl
	end if
END FUNCTION locate 

function FCNtransition(x)
implicit none

double precision :: FCNtransition
double precision ,intent(in) :: x
double precision  :: con, lab
double precision  :: vals(2), VM(nh,ns), temp(nh)
integer  :: ih, is, inds(2)
integer :: gcp
double precision :: lfc
double precision :: alevel, yinc

alevel=grida(ac)
net=zero

    if ( economy .eq. 'u' ) then
	
    gcp=2

        if ( tc .lt. jr ) then

            if ( work .eq. 1 ) then
            lfc=phi_l+phi_h(hc)
            lab=gridl(il)

            con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+ &
            & (1-taul(date)-taup(date))*w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x

            else if ( work .eq. 0 ) then

            lfc=phi_h(hc)
            lab=zero
            con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+ &
            & (1-taul(date)-taup(date))*w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x

            end if

        elseif ( tc .ge. jr ) then

            if ( work .eq. 1 ) then
            lfc=phi_h(hc)+phi_l
            lab=gridl(il)
            con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x+(1-taul(date)-taup(date))*w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
            
            else if ( work .eq. 0 ) then
            lfc=phi_h(hc)
            lab=zero
            con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x
            end if
            
        endif

    end if

    if ( economy .eq. 'm' .and. buypvt .eq. 0 .and. ( gc .eq. 1 .or. gc .eq. 2 ) ) then

    gcp=2
        
        if ( tc .lt. jr ) then

            if ( work .eq. 1 ) then
            lfc=phi_l+phi_h(hc)
                if ( gc .eq. 1 ) then
                lab=gridl(il)
                yinc=w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+r(date)*(grida(ac))
                xmed=(1-cov_p(hc))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x-(1-cov_p(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))

                else if ( gc .eq. 2 ) then

                lab=gridl(il)
                yinc=w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+r(date)*(grida(ac))
                xmed=e_h(hc,tc)
                
                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                    if ( pr_g(ec,hc,tc,date) .lt. min_pr(date)*yinc .and. tc .gt. 1 ) then
                    net=-(1-elig)*max(min_pen(date),pen_rate(date)*(yinc-file_min(date)))
                    else
                    net=zero
                    end if					
                                                                
                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x-e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))+net

                end if

            else if ( work .eq. 0 ) then
            
            lfc=phi_h(hc)

                if ( gc .eq. 1 ) then		
                lab=zero
                yinc=r(date)*(grida(ac))
                xmed=(1-cov_p(hc))*e_h(hc,tc)
                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))-x&
                -(1-cov_p(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))

                else if ( gc .eq. 2 ) then

                lab=zero
                yinc=r(date)*(grida(ac))
                xmed=e_h(hc,tc)
                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                    if ( pr_g(ec,hc,tc,date) .lt. min_pr(date)*yinc .and. tc .gt. 1 ) then
                    net=-(1-elig)*max(min_pen(date),pen_rate(date)*(yinc-file_min(date)))
                    else
                    net=zero
                    end if					
					
                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))-x&
                -e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))+net

                end if
                
            endif

        elseif ( tc .ge. jr ) then


            if ( gc .eq. 1 ) then

                if ( work .eq. 1 ) then

                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SS(ec,date)+r(date)*(grida(ac))+w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_p(hc))*(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x-&
                (1-cov_p(hc))*(1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SS(ec,date)+r(date)*(grida(ac))
                xmed=(1-cov_p(hc))*(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x-&
                (1-cov_p(hc))*(1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))
                end if
                
            else if ( gc .eq. 2 ) then

                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l              
                lab=gridl(il)
                yinc=SS(ec,date)+r(date)*(grida(ac))+w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)
	
                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x-&
                (1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)                
                lab=zero
                yinc=SS(ec,date)+r(date)*(grida(ac))
                xmed=(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)
	
                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x-&
                (1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))
                end if
                
            end if
        endif
    end if

    if ( economy .eq. 'm' .and. buypvt .eq. 1 .and. ( gc .eq. 1 .or. gc .eq. 2 ) ) then

    gcp=1
	
	if ( tc .lt. jr ) then

            if ( work .eq. 1 ) then
            lfc=phi_l+phi_h(hc)

                if ( gc .eq. 1 ) then

                lab=gridl(il)
                yinc=w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+r(date)*(grida(ac))
                xmed=(1-cov_p(hc))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                net=(1-elig)*sub(yinc,pr_g(ec,hc,tc,date))
					
                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x-&
                (1-cov_p(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)+net

                else if ( gc .eq. 2 ) then

                lab=gridl(il)
                yinc=w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+r(date)*(grida(ac))
                xmed=e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                    if ( pr_g(ec,hc,tc,date) .lt. min_pr(date)*yinc ) then
                        if ( tc .gt. 1 ) then
                        net=(1-elig)*(-max(min_pen(date),pen_rate(date)*(yinc-file_min(date)))+sub(yinc,pr_g(ec,hc,tc,date)))
                        else
                        net=(1-elig)*(sub(yinc,pr_g(ec,hc,tc,date)))
                        end if
                    else
                    net=(1-elig)*sub(yinc,pr_g(ec,hc,tc,date))
                    end if										
					
                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x-&
                e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)+net

                end if

            else if ( work .eq. 0 ) then
            
            lfc=phi_h(hc)

                if ( gc .eq. 1 ) then		

                lab=zero
                yinc=r(date)*(grida(ac))
                xmed=(1-cov_p(hc))*e_h(hc,tc)
                    call medicaid_eligible (elig,yinc,alevel,xmed,date)
					
                net=(1-elig)*sub(yinc,pr_g(ec,hc,tc,date))

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))-x-&
                (1-cov_p(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)+net

                else if ( gc .eq. 2 ) then

                lab=zero
                yinc=r(date)*(grida(ac))
                xmed=e_h(hc,tc)
                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                    if ( pr_g(ec,hc,tc,date) .lt. min_pr(date)*yinc ) then
                        if ( tc .gt. 1 ) then
                        net=(1-elig)*(-max(min_pen(date),pen_rate(date)*(yinc-file_min(date)))+sub(yinc,pr_g(ec,hc,tc,date)))
                        else
                        net=(1-elig)*(sub(yinc,pr_g(ec,hc,tc,date)))
                        end if
                    else
                    net=(1-elig)*sub(yinc,pr_g(ec,hc,tc,date))
                    end if										
					
                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))-x-&
                e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)+net
                end if
                
            endif

        elseif ( tc .ge. jr ) then
		
		
            if ( gc .eq. 1 ) then
            
                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SS(ec,date)+r(date)*(grida(ac))+w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_p(hc))*(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x&
                -(1-cov_p(hc))*(1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SS(ec,date)+r(date)*(grida(ac))
                xmed=(1-cov_p(hc))*(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x&
                -(1-cov_p(hc))*(1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)
                end if
                
            else if ( gc .eq. 2 ) then
            
                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SS(ec,date)+r(date)*(grida(ac))+w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x&
                -(1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)                
                lab=zero
                yinc=SS(ec,date)+r(date)*(grida(ac))
                xmed=(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x&
                -(1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)
                end if
                
            end if
        endif

    end if


    if ( economy .eq. 'm' .and. gc .eq. 3 ) then

        if ( tc .lt. jr .and. buypvt .eq. 0 ) then
        
        gcp=3
        
            if ( work .eq. 1 ) then
            
            lfc=phi_l+phi_h(hc)
            lab=gridl(il)
            yinc=w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+r(date)*(grida(ac))
            xmed=(1-cov_e(hc))*e_h(hc,tc)

                call medicaid_eligible (elig,yinc,alevel,xmed,date)

            con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+(1-taul(date)-taup(date))* &
            w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x-&
            (1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-tauf(date)

            else if ( work .eq. 0 ) then

                if ( sick .eq. 1 ) then

                lfc=phi_h(hc)
                lab=zero
                yinc=r(date)*(grida(ac))
                xmed=(1-cov_e(hc))*e_h(hc,tc)
                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))-x-&
                (1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))

                else if ( sick .eq. 0 ) then

                    if ( lmin .gt. zero ) then
                    lfc=phi_l+phi_h(hc)
                    else
                    lfc=phi_h(hc)
                    end if

                lab=lmin
                yinc=w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+r(date)*(grida(ac))
                xmed=(1-cov_e(hc))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x-&
                (1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-tauf(date)

                end if
            endif

        else if ( tc .lt. jr .and. buypvt .eq. 1 ) then
        
        gcp=1

            if ( work .eq. 1 ) then

            lfc=phi_l+phi_h(hc)
            lab=gridl(il)

            yinc=w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+r(date)*(grida(ac))
            xmed=(1-cov_e(hc))*e_h(hc,tc)

                call medicaid_eligible (elig,yinc,alevel,xmed,date)

            con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+(1-taul(date)-taup(date))* &
            w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x&
            -(1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)-tauf(date)

            else if ( work .eq. 0 ) then

                if ( sick .eq. 1 ) then

                lfc=phi_h(hc)
                lab=zero
                yinc=r(date)*(grida(ac))
                xmed=(1-cov_e(hc))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))-x-&
                (1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)

                else if ( sick .eq. 0 ) then

                    if ( lmin .gt. zero ) then
                    lfc=phi_l+phi_h(hc)
                    else
                    lfc=phi_h(hc)
                    end if

                lab=lmin
                yinc=w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+r(date)*(grida(ac))
                xmed=(1-cov_e(hc))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x-tauf(date)-&
                (1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)

                end if
            endif

        elseif ( tc .ge. jr ) then


            if ( buypvt .eq. 1 ) then
            gcp=1
                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SS(ec,date)+r(date)*(grida(ac))+w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x-&
                (1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SS(ec,date)+r(date)*(grida(ac))
                xmed=(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x-&
                (1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))-pr_g(ec,hc,tc,date)
                end if
                
            else if ( buypvt .eq. 0 ) then
            gcp=3

                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SS(ec,date)+r(date)*(grida(ac))+w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x-&
                (1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))+(1-taul(date)-taup(date))* &
                w(date)*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SS(ec,date)+r(date)*(grida(ac))
                xmed=(1-cov_m(date))*e_h(hc,tc)

                    call medicaid_eligible (elig,yinc,alevel,xmed,date)

                con=(1+r(date)*(1-tauk(date)))*(grida(ac)+Tr(date))+SS(ec,date)-x-&
                (1-cov_m(date))*e_h(hc,tc)*((1-elig)+elig*(1-cov_md(date,tc)))
                end if
                
            end if
        endif
    end if

    call basefun(grida,na,x,vals,inds)

    do ih=1,nh
        do is=1,ns
        VM(ih,is)=vals(1)*Vp(gcp,ec,ih,is,inds(1),tc+1)+vals(2)*Vp(gcp,ec,ih,is,inds(2),tc+1)
        enddo
    temp(ih)=sum(VM(ih,1:ns)*pi(ec,1:ns,sc))
    end do

FCNtransition=-( U(con,lab,lfc)+bbeta*psi_t(ec,hc,tc,date)*sum(temp(1:nh)*pi_h(ec,tc,1:nh,hc)) )
    cmax=con
lmax=lab

end function FCNtransition

function FCNss(x)
implicit none

double precision :: FCNss
double precision,intent(in) :: x
double precision :: con, lab
double precision :: vals(2), VM(nh,ns), temp(nh)
integer :: ih, is, inds(2)
integer :: gcp
double precision :: lfc
double precision :: alevel, yinc

alevel=grida(ac)
net=zero

    !health expense is covered
    if ( economy .eq. 'u' ) then
    !no pvt insurance tomorrow
    gcp=2
        if ( tc .lt. jr ) then

            if ( work .eq. 1 ) then
            lfc=phi_l+phi_h(hc)
            lab=gridl(il)
            con=(1+rss*(1-taukss))*(grida(ac)+Trss)+ &
            & (1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x		
            else if ( work .eq. 0 ) then
            lfc=phi_h(hc)
            lab=zero
            con=(1+rss*(1-taukss))*(grida(ac)+Trss)+ &
            & (1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x
            end if

        elseif ( tc .ge. jr ) then

            if ( work .eq. 1 ) then
            lfc=phi_l+phi_h(hc)
            lab=gridl(il)
            con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
            else if ( work .eq. 0 ) then
            lfc=phi_h(hc)
            lab=zero
            con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x
            end if
            
        endif

    end if

    if ( economy .eq. 'm' .and. buypvt .eq. 0 .and. ( gc .eq. 1 .or. gc .eq. 2 ) ) then
    !no pvt insurance tomorrow
    gcp=2

        if ( tc .lt. jr ) then

            if ( work .eq. 1 ) then

                if ( gc .eq. 1 ) then
                lfc=phi_l+phi_h(hc)
                lab=gridl(il)
                yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+rss*(grida(ac))
                xmed=(1-cov_p(hc))*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x&
                -(1-cov_p(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))


                else if ( gc .eq. 2 ) then

                lfc=phi_l+phi_h(hc)
                lab=gridl(il)
                yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+rss*(grida(ac))
                xmed=e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)
					
                    if ( pr_gss(ec,hc,tc) .lt. min_prss*yinc .and. tc .gt. 1 ) then
                    net=-(1-elig)*max(min_penss,pen_ratess*(yinc-file_minss))
                    else
                    net=zero
                    end if

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x&
                -e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))+net

                end if

            else if ( work .eq. 0 ) then

                if ( gc .eq. 1 ) then
                
                lfc=phi_h(hc)
                lab=zero
                yinc=rss*(grida(ac))
                xmed=(1-cov_p(hc))*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)-x&
                -(1-cov_p(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))
	

                else if ( gc .eq. 2 ) then
                
                lfc=phi_h(hc)
                lab=zero
                yinc=rss*(grida(ac))
                xmed=e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                    if ( pr_gss(ec,hc,tc) .lt. min_prss*yinc .and. tc .gt. 1 ) then
                    net=-(1-elig)*max(min_penss,pen_ratess*(yinc-file_minss))
                    else
                    net=zero
                    end if
					
                con=(1+rss*(1-taukss))*(grida(ac)+Trss)-x&
                -e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))+net

                end if

            end if

        elseif ( tc .ge. jr ) then

            if ( gc .eq. 1 ) then
            
                if ( work .eq. 1 ) then
                
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SSss(ec)+rss*(grida(ac))+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_p(hc))*(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_p(hc))*(1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SSss(ec)+rss*(grida(ac))
                xmed=(1-cov_p(hc))*(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_p(hc))*(1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))
                end if
                
            else if ( gc .eq. 2 ) then
            
                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SSss(ec)+rss*(grida(ac))+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab

                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SSss(ec)+rss*(grida(ac))
                xmed=(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))
                end if
                
            end if
        endif
    end if

    if ( economy .eq. 'm' .and. buypvt .eq. 1 .and. ( gc .eq. 1 .or. gc .eq. 2 ) ) then

    gcp=1

        if ( tc .lt. jr ) then

            if ( work .eq. 1 ) then

                if ( gc .eq. 1 ) then
                
                lfc=phi_l+phi_h(hc)
                lab=gridl(il)
                yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+rss*(grida(ac))
                xmed=(1-cov_p(hc))*e_h(hc,tc)
                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                net=(1-elig)*sub_ss(yinc,pr_gss(ec,hc,tc))
                                
                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x&
                -(1-cov_p(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)+net

                else if ( gc .eq. 2 ) then
                
                lfc=phi_l+phi_h(hc)
                lab=gridl(il)
                yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+rss*(grida(ac))
                xmed=e_h(hc,tc)
                                    
                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                    if ( pr_gss(ec,hc,tc) .lt. min_prss*yinc ) then
                    
                        if ( tc .gt. 1 ) then
                        net=(1-elig)*(-max(min_penss,pen_ratess*(yinc-file_minss))+sub_ss(yinc,pr_gss(ec,hc,tc)))
                        else
                        net=(1-elig)*(sub_ss(yinc,pr_gss(ec,hc,tc)))
                        end if
                        
                    else
                    net=(1-elig)*sub_ss(yinc,pr_gss(ec,hc,tc))
                    end if
										
                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x&
                -e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)+net

                end if

            else if ( work .eq. 0 ) then
                
            lfc=phi_h(hc)

                if ( gc .eq. 1 ) then
                lab=zero
                yinc=rss*(grida(ac))
                xmed=(1-cov_p(hc))*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)
					
                net=(1-elig)*sub_ss(yinc,pr_gss(ec,hc,tc))

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)-x&
                -(1-cov_p(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)+net

                else if ( gc .eq. 2 ) then
                        
                lab=zero
                yinc=rss*(grida(ac))
                xmed=e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                    if ( pr_gss(ec,hc,tc) .lt. min_prss*yinc ) then
                    
                        if ( tc .gt. 1 ) then
                        net=(1-elig)*(-max(min_penss,pen_ratess*(yinc-file_minss))+sub_ss(yinc,pr_gss(ec,hc,tc)))
                        else
                        net=(1-elig)*(sub_ss(yinc,pr_gss(ec,hc,tc)))
                        end if
                        
                    else
                    net=(1-elig)*sub_ss(yinc,pr_gss(ec,hc,tc))
                    end if
					
                con=(1+rss*(1-taukss))*(grida(ac)+Trss)-x&
                -e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)+net

                end if

            end if

        elseif ( tc .ge. jr ) then


            if ( gc .eq. 1 ) then
            
                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SSss(ec)+rss*(grida(ac))+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_p(hc))*(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_p(hc))*(1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SSss(ec)+rss*(grida(ac))
                xmed=(1-cov_p(hc))*(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_p(hc))*(1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)
                end if
                
            else if ( gc .eq. 2 ) then
            
                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SSss(ec)+rss*(grida(ac))+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SSss(ec)+rss*(grida(ac))
                xmed=(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)
                end if
                
            end if

        endif

    end if

    !on employer insurance
    if ( economy .eq. 'm' .and. gc .eq. 3 ) then

        if ( tc .lt. jr .and. buypvt .eq. 0 ) then
        gcp=3
        
            if ( work .eq. 1 ) then

            lfc=phi_l+phi_h(hc)
            lab=gridl(il)
            yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+rss*(grida(ac))
            xmed=(1-cov_e(hc))*e_h(hc,tc)

                call medicaid_eligibless (elig,yinc,alevel,xmed)

            con=(1+rss*(1-taukss))*(grida(ac)+Trss)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x&
            -(1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-taufss


            else if ( work .eq. 0 ) then

                if ( sick .eq. 1 ) then
                !if sick, may work 0
                lfc=phi_h(hc)
                lab=zero

                yinc=rss*(grida(ac))
                xmed=(1-cov_e(hc))*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)-x&
                -(1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))

                else if ( sick .eq. 0 ) then

                !if not sick,work lmin
                    if ( lmin .gt. zero ) then
                    lfc=phi_l+phi_h(hc)
                    else
                    lfc=phi_h(hc)
                    end if

                lab=lmin
                yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+rss*(grida(ac))
                xmed=(1-cov_e(hc))*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab&
                -x-(1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-taufss

                endif
            end if

        else if ( tc .lt. jr .and. buypvt .eq. 1 ) then

        gcp=1

            if ( work .eq. 1 ) then
            lfc=phi_l+phi_h(hc)
            lab=gridl(il)

            yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+rss*(grida(ac))
            xmed=(1-cov_e(hc))*e_h(hc,tc)

                call medicaid_eligibless (elig,yinc,alevel,xmed)

            con=(1+rss*(1-taukss))*(grida(ac)+Trss)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x&
            -(1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)-taufss

            else if ( work .eq. 0 ) then

                if ( sick .eq. 1 ) then
                !if sick, may work 0
                lfc=phi_h(hc)
                lab=zero

                yinc=rss*(grida(ac))
                xmed=(1-cov_e(hc))*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)-x&
                -(1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)

                else if ( sick .eq. 0 ) then
                !else work, lmin
				
                    if ( lmin .gt. zero ) then
                    lfc=phi_l+phi_h(hc)
                    else
                    lfc=phi_h(hc)
                    end if

                lab=lmin
                yinc=wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab+rss*(grida(ac))
                xmed=(1-cov_e(hc))*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab-x&
                -(1-cov_e(hc))*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)-taufss

                endif
            end if

        elseif ( tc .ge. jr ) then

            if ( buypvt .eq. 1 ) then	
            gcp=1
                
                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SSss(ec)+rss*(grida(ac))+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SSss(ec)+rss*(grida(ac))
                xmed=(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))-pr_gss(ec,hc,tc)
                end if

            else if ( buypvt .eq. 0 ) then
            gcp=3
            
                if ( work .eq. 1 ) then
                lfc=phi_h(hc)+phi_l
                lab=gridl(il)
                yinc=SSss(ec)+rss*(grida(ac))+wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                xmed=(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))+(1-taulss-taupss)*wss*eta(ec,sc)*ep(ec,tc)*z_h(hc)*lab
                
                else if ( work .eq. 0 ) then
                lfc=phi_h(hc)
                lab=zero
                yinc=SSss(ec)+rss*(grida(ac))
                xmed=(1-cov_mss)*e_h(hc,tc)

                    call medicaid_eligibless (elig,yinc,alevel,xmed)

                con=(1+rss*(1-taukss))*(grida(ac)+Trss)+SSss(ec)-x-&
                (1-cov_mss)*e_h(hc,tc)*((1-elig)+elig*(1-cov_mdss(tc)))
                end if
            
            end if
        endif
    end if

    call basefun(grida,na,x,vals,inds)
    
!    if ( tc .lt. J ) then
        
        do ih=1,nh
            do is=1,ns
            VM(ih,is)=vals(1)*Vss(gcp,ec,ih,is,inds(1),tc+1)+vals(2)*Vss(gcp,ec,ih,is,inds(2),tc+1)
            enddo
        temp(ih)=sum(VM(ih,1:ns)*pi(ec,1:ns,sc))
        end do

    FCNss=-(U(con,lab,lfc)+bbeta*psi(ec,hc,tc)*sum(temp(1:nh)*pi_h(ec,tc,1:nh,hc)))

    lmax=lab
    cmax=con

!     else if ( tc .eq. J ) then
!     
!     FCNss=-(U(con,lab,lfc)+10000*bbeta*(x**(1-sigma_bq))/(1-sigma_bq))
! 
!     lmax=lab
!     cmax=con
! 
!     end if
    
end function FCNss

subroutine medicaid_eligible (eligible,y,a,x,t)
implicit none

integer :: eligible, t
double precision, intent(in) :: y, a, x

	if ( ( y .le. ycat(t) .and.  a .le. kcat(t) ) .or. ( y-x .le. ymn(t) .and. a .le. kmn(t) ) ) then
	eligible=1
	else
	eligible=0
	end if

end subroutine medicaid_eligible

subroutine medicaid_eligibless (eligible,y,a,x)
implicit none

integer :: eligible
double precision, intent(in) :: y, a, x

	if ( ( y .le. ycatss .and.  a .le. kcatss ) .or. ( y-x .le. ymnss .and. a .le. kmnss ) ) then
	eligible=1
	else
	eligible=0
	end if

end subroutine medicaid_eligibless

function sub_ss (yinc,pr)
implicit none

double precision :: sub_ss
double precision :: yinc,pr

        if ( yinc .lt. 1.33*FPL ) then
        sub_ss=ACAsubss*max(zero,pr-.02*yinc)
        else if ( yinc .ge. 1.33*FPL .and. yinc .lt. 1.5*FPL ) then
        sub_ss=ACAsubss*max(zero,pr-.03*yinc)
        else if ( yinc .ge. 1.5*FPL .and. yinc .lt. 2*FPL ) then
        sub_ss=ACAsubss*max(zero,pr-.04*yinc)
        else if ( yinc .ge. 2*FPL .and. yinc .lt. 2.5*FPL ) then
        sub_ss=ACAsubss*max(zero,pr-.063*yinc)
        else if ( yinc .ge. 2.5*FPL .and. yinc .lt. 3*FPL ) then
        sub_ss=ACAsubss*max(zero,pr-.081*yinc)
        else if ( yinc .ge. 3*FPL .and. yinc .lt. 4*FPL ) then
        sub_ss=ACAsubss*max(zero,pr-.095*yinc)
        else        
        sub_ss=zero
        end if    
    
end function sub_ss


function sub (yinc,pr)
implicit none

double precision :: sub
double precision :: yinc,pr

        if ( yinc .lt. 1.33*FPL ) then
        sub=ACAsub(date)*max(zero,pr-.02*yinc)
        else if ( yinc .ge. 1.33*FPL .and. yinc .lt. 1.5*FPL ) then
        sub=ACAsub(date)*max(zero,pr-.03*yinc)
        else if ( yinc .ge. 1.5*FPL .and. yinc .lt. 2*FPL ) then
        sub=ACAsub(date)*max(zero,pr-.04*yinc)
        else if ( yinc .ge. 2*FPL .and. yinc .lt. 2.5*FPL ) then
        sub=ACAsub(date)*max(zero,pr-.063*yinc)
        else if ( yinc .ge. 2.5*FPL .and. yinc .lt. 3*FPL ) then
        sub=ACAsub(date)*max(zero,pr-.081*yinc)
        else if ( yinc .ge. 3*FPL .and. yinc .lt. 4*FPL ) then
        sub=ACAsub(date)*max(zero,pr-.095*yinc)
        else        
        sub=zero
        end if    
    
end function sub


END MODULE mini