program revise

use params

implicit none
include 'mpif.h'

double precision :: codetime,codestart,codefinish 

! Parallel computing
call MPI_INIT (ierr)
call MPI_COMM_SIZE (mpi_comm_world, nproc, ierr)
call MPI_COMM_RANK (mpi_comm_world, rank, ierr)


call cpu_time(codestart)


! Grid for asset holdings and indivisible labor
call grid
! Policy parameters
call policies
! Demographics and age efficiency
call demographics

! Calibrate parameters
call calibrate

! Re-compute initial steady state given new parameters from calibrate.f90. 
call markov
call instst
								
! Compute final steady state
call fistst

! Compute the transition between the steady states. This subroutine calls welfare.90 to solve for the welfare effects of the policy reform
call transition

call cpu_time(codefinish)

	codetime=codefinish-codestart
	if ( rank .eq. 0 ) then
	PRINT*,'code time=',codetime/60.
	end if

call MPI_FINALIZE(ierr)

end program revise